<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfInterfacePersonResult_V9 ArrayType
 * @subpackage Arrays
 */
class ArrayOfInterfacePersonResult_V9 extends AbstractStructArrayBase
{
    /**
     * The InterfacePersonResult_V9
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\InterfacePersonResult_V9[]
     */
    public $InterfacePersonResult_V9;
    /**
     * Constructor method for ArrayOfInterfacePersonResult_V9
     * @uses ArrayOfInterfacePersonResult_V9::setInterfacePersonResult_V9()
     * @param \StructType\InterfacePersonResult_V9[] $interfacePersonResult_V9
     */
    public function __construct(array $interfacePersonResult_V9 = array())
    {
        $this
            ->setInterfacePersonResult_V9($interfacePersonResult_V9);
    }
    /**
     * Get InterfacePersonResult_V9 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\InterfacePersonResult_V9[]|null
     */
    public function getInterfacePersonResult_V9()
    {
        return isset($this->InterfacePersonResult_V9) ? $this->InterfacePersonResult_V9 : null;
    }
    /**
     * This method is responsible for validating the values passed to the setInterfacePersonResult_V9 method
     * This method is willingly generated in order to preserve the one-line inline validation within the setInterfacePersonResult_V9 method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateInterfacePersonResult_V9ForArrayConstraintsFromSetInterfacePersonResult_V9(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfInterfacePersonResult_V9InterfacePersonResult_V9Item) {
            // validation for constraint: itemType
            if (!$arrayOfInterfacePersonResult_V9InterfacePersonResult_V9Item instanceof \StructType\InterfacePersonResult_V9) {
                $invalidValues[] = is_object($arrayOfInterfacePersonResult_V9InterfacePersonResult_V9Item) ? get_class($arrayOfInterfacePersonResult_V9InterfacePersonResult_V9Item) : sprintf('%s(%s)', gettype($arrayOfInterfacePersonResult_V9InterfacePersonResult_V9Item), var_export($arrayOfInterfacePersonResult_V9InterfacePersonResult_V9Item, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The InterfacePersonResult_V9 property can only contain items of type \StructType\InterfacePersonResult_V9, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set InterfacePersonResult_V9 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\InterfacePersonResult_V9[] $interfacePersonResult_V9
     * @return \ArrayType\ArrayOfInterfacePersonResult_V9
     */
    public function setInterfacePersonResult_V9(array $interfacePersonResult_V9 = array())
    {
        // validation for constraint: array
        if ('' !== ($interfacePersonResult_V9ArrayErrorMessage = self::validateInterfacePersonResult_V9ForArrayConstraintsFromSetInterfacePersonResult_V9($interfacePersonResult_V9))) {
            throw new \InvalidArgumentException($interfacePersonResult_V9ArrayErrorMessage, __LINE__);
        }
        if (is_null($interfacePersonResult_V9) || (is_array($interfacePersonResult_V9) && empty($interfacePersonResult_V9))) {
            unset($this->InterfacePersonResult_V9);
        } else {
            $this->InterfacePersonResult_V9 = $interfacePersonResult_V9;
        }
        return $this;
    }
    /**
     * Add item to InterfacePersonResult_V9 value
     * @throws \InvalidArgumentException
     * @param \StructType\InterfacePersonResult_V9 $item
     * @return \ArrayType\ArrayOfInterfacePersonResult_V9
     */
    public function addToInterfacePersonResult_V9(\StructType\InterfacePersonResult_V9 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\InterfacePersonResult_V9) {
            throw new \InvalidArgumentException(sprintf('The InterfacePersonResult_V9 property can only contain items of type \StructType\InterfacePersonResult_V9, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->InterfacePersonResult_V9[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\InterfacePersonResult_V9|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\InterfacePersonResult_V9|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\InterfacePersonResult_V9|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\InterfacePersonResult_V9|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\InterfacePersonResult_V9|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string InterfacePersonResult_V9
     */
    public function getAttributeName()
    {
        return 'InterfacePersonResult_V9';
    }
}
